!
! License-Identifier: GPL
!
! Copyright (C) 2015 The Yambo Team
!
! Authors (see AUTHORS file for details): AM
!
integer function io_RIM(ID)
 !
 use pars,           ONLY:SP
 use R_lattice,      ONLY:RIM_ng,RIM_n_rand_pts,RIM_is_diagonal,RL_vol,RIM_RL_vol,&
&                         RIM_id_epsm1_reference,RIM_epsm1,RIM_anisotropy,RIM_qpg,&
&                         nqibz
 use IO_m,           ONLY:io_sec,read_is_on,io_status,write_is_on
 use IO_int,         ONLY:io_connect,io_disconnect,io_header,io_elemental,io_bulk,ver_is_gt_or_eq
 !
#include <y_memory.h>
 !
 integer :: ID
 ! 
 ! Work Space
 !
 real(SP)            ::RL_vol_disk
 integer             ::RIM_ng_disk
 !
 io_RIM=io_connect(desc="RIM",type=2,ID=ID)
 !
 if (io_RIM/=0) goto 1
 !
 if (any((/io_sec(ID,:)==1/))) then
   !
   ! First get the DB version
   io_RIM=io_header(ID)
   if (io_RIM/=0) goto 1   
   !
   if (ver_is_gt_or_eq(ID,(/5,1,0/)).or.write_is_on(ID)) then
     io_RIM=io_header(ID,QPTS=.true.,R_LATT=.true.,IMPOSE_SN=.true.,CUTOFF=.true.)
   else
     io_RIM=io_header(ID,QPTS=.true.,R_LATT=.true.,IMPOSE_SN=.true.,CUTOFF=.false.)
   endif
   if (io_RIM/=0) goto 1   
   !
   RL_vol_disk=RL_vol
   !
   call io_elemental(ID,VAR="PARS",VAR_SZ=10,MENU=0)
   !
   call io_elemental(ID,I0=RIM_ng,DB_I0=RIM_ng_disk,&
&       VAR=' Coulombian RL components        ',CHECK=.true.,OP=(/"<="/))
   call io_elemental(ID,L0=RIM_is_diagonal,&
&       VAR=' Coulombian diagonal components  ',CHECK=.true.,OP=(/"=="/))
   call io_elemental(ID,I0=RIM_n_rand_pts,&
&       VAR=' RIM random points               ',CHECK=.true.,OP=(/"=="/))
   call io_elemental(ID,R0=RIM_RL_vol,&
&       VAR=' RIM  RL volume             [a.u.]')
   call io_elemental(ID,R0=RL_vol_disk,&
&       VAR=' Real RL volume             [a.u.]')
   call io_elemental(ID,I0=RIM_id_epsm1_reference,&
&       VAR=' Eps^-1 reference component       ',CHECK=.true.,OP=(/"=="/))
   call io_elemental(ID,R1=RIM_epsm1,&
&       VAR=' Eps^-1 components                ',CHECK=.true.,OP=(/"==","==","=="/))
   call io_elemental(ID,R0=RIM_anisotropy,&
&       VAR=' RIM anysotropy factor            ')
   !
   call io_elemental(ID,VAR="",VAR_SZ=0)
   io_RIM=io_status(ID)
   if (io_RIM/=0) goto 1
 endif
 !
 if (any((/io_sec(ID,:)==2/))) then
   !
   if (read_is_on(ID)) then
     YAMBO_ALLOC(RIM_qpg,(nqibz,RIM_ng,RIM_ng))
   endif
   !
   call io_bulk(ID,VAR="RIM_qpg",VAR_SZ=(/shape(RIM_qpg)/))
   call io_bulk(ID,R3=RIM_qpg)
   !
 endif
 !
1 call io_disconnect(ID=ID)
 !
end function
